# nextdraw_naming.py
# Part of the NextDraw driver for Inkscape
# http://bantamtools.com
#
# See version_string below for detailed version number.

'''
# Copyright 2025 Windell H. Oskay, Bantam Tools

The MIT License (MIT)

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all
copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
SOFTWARE.

'''

from nextdrawcore import nextdraw

from nextdrawcore.plot_utils_import import from_dependency_import  # plotink
inkex = from_dependency_import('ink_extensions.inkex')


class NextDrawNamingClass(inkex.Effect):  # pylint: disable=too-few-public-methods
    ''' Main class for NextDraw Naming function '''

    def __init__(self):
        inkex.Effect.__init__(self)

        self.version_string = "2.2.1"

        self.arg_parser.add_argument("--mode", action="store", type=str,
                                     dest="mode", default="utility",
                                     help="Mode (or GUI tab) selected")
        self.arg_parser.add_argument("--nickname", action="store", type=str,
                                     dest="nickname", default="", help="The nickname to assign")

    def effect(self):
        '''Main entry point: check to see which mode/tab is selected, and act accordingly.'''

        # Input sanitization:
        self.options.mode = self.options.mode.strip("\"")
        self.options.nickname = self.options.nickname.strip("\"")
        self.options.nickname = self.options.nickname.strip()

        if self.options.mode == "about":
            return

        nd_ref = nextdraw.NextDraw()

        nd_ref.called_externally = "NextDraw Naming"

        # Pass the document off for plotting
        nd_ref.document = self.document

        nd_ref.options.mode = "utility"
        nd_ref.options.model = 1
        if self.options.mode == "list_names":
            nd_ref.options.utility_cmd = "list_names"
        if self.options.mode == "write_name":
            nd_ref.options.utility_cmd = "write_name" + self.options.nickname

        nd_ref.effect()


if __name__ == '__main__':
    e = NextDrawNamingClass()
    e.affect()
